

//// my play with pixel movement and display
//// this uses 10 bits of a 16 bit integer
//// B0000 0011 1111 1111 are counted in a 10 loop
//// this lights corresponding led 1=on 
//// 
////    328 micro
////

#include <LowPower.h>
#include <Adafruit_NeoPixel.h>


#define LED_PIN    6   //neopix drive

#define LED_COUNT  41  //total leds

#define LED_Vcc    12  //Vcc to neos via transistor

#define rows       4   //4 = top, topmid, btmmid, btm

#define brite      10  //0-255

#define maxBit     10  //B0000 0011 1111 1111 = 16bit int

#define pend      1111 //pattern end do restart


// Declare our NeoPixel strip object:
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

byte colorWheel;     //0-255 see random() in loop
byte pattN  =  0; //selects 'array of allPatterns' place

////markers, arrays can't call functions
 const int rainB[]={ 2222 }; //call rainbow()
 const int sleepP[]={ 3333 }; //call lowPower()

/////// pattern based on packets of 4 ////////
//////// delay time V  , V repeat cycles

 const int test[]={2000,40,
  1023,0,0,0, 0,1023,0,0, 0,0,1023,0, 0,0,0,1023, 
  1,0,0,0,    0,1,0,0,    0,0,1,0,    0,0,0,1, pend};
 
 const int dot[]= {28,300,  
  32,32,32,32, 0,0,0,0, pend};

 const int blinks[]={70,20,  
  1023,1023,1023,1023, 0,0,0,0, pend};
 
 const int blink[]={80,1,  
  1023,1023,1023,1023, 0,0,0,0, pend};

 const int pulse[]={70,30,
  32,32,32,32, 470,470,470,470, 521,521,521,521, 0,0,0,0,
  521,521,521,521, 470,470,470,470, 32,32,32,32, 0,0,0,0,
  pend};

 const int allBlink[]={80,20,
  1023,1023,1023,1023, 0,0,0,0, pend};
  
 const int rspin[]={40,10,
  2,2,256,256, 64,64,16,16, 128,128,4,4, 256,256,2,2,
  16,16,64,64, 4,4,128,128,  pend};

 const int lspin[]={40,10,
   2,2,256,256, 4,4,128,128, 16,16,64,64, 256,256,2,2,
   128,128,4,4, 64,64,16,16, 
   pend};

 const int ccw[]={70,22,
  512,1,8,8,    256,64,4,4,   16,128,2,2,   8,512,1,1,
  4,256,64,64,  2,16,128,128,  1,8,512,512,  64,4,256,256,   
  128,2,16,16, 
  pend};

 const int cw[]={70,22,
  512,1,8,8,    128,2,16,16,   64,4,256,256,   1,8,512,512,
  2,16,128,128,  4,256,64,64,   8,512,1,1,     16,128,2,2,   
  256,64,4,4, 
  pend};

 const int vvv[]={60,20,
  512,0,0,0, 384,0,0,0, 80,0,0,0, 9,0,0,0,
  0,513,0,0, 0,258,0,0, 0,20,0,0, 0,8,0,0,
  0,0,8,0, 0,0,20,0, 0,0,258,0, 0,0,513,0,
  0,0,0,9, 0,0,0,80, 0,0,0,384, 0,0,0,512,
  pend};

 const int lftrt[]={60,14,
  792,792,1,1,  164,164,66,66,  66,66,164,164,  1,1,792,792,
  pend}; 
 
 const int rtlft[]={60,14,
  705,15,512,8,  290,112,384,20,  20,384,112,290,  8,512,15,705,
  pend};
 
 const int tbstring[]={30,20,
  512,0,0,0,  384,0,0,0,   112,0,0,0,    15,0,0,0,
  0,705,8,0,  0,290,20,0,  0,20,290,0,   0,8,705,0, 
  0,0,0,15,   0,0,0,112,   0,0,0,384,    0,0,0,512, 
  pend};

 const int topdn[]={40,30,
  512,705,8,15,  384,290,20,112, 112,20,290,384,  15,8,705,512,
  pend};

 const int btmup[]={40,30, 
  15,8,705,512,  112,20,290,384, 384,290,20,112,  512,705,8,15,
  pend};

////////////////////     
 const int* allPatts[]={
  dot, blink,
  pulse, blink, rspin, blink,
  lspin, blink, rspin, blink,
  btmup, topdn, lftrt, rtlft,
  tbstring, cw, blink, ccw,
  allBlink, rainB, sleepP };

  

void setup() {
  pinMode(2, INPUT);  //d2 interrupt
  digitalWrite (2, HIGH); // enable pull-up 20k
    // or 50k to Vcc 
  pinMode(13,INPUT);  //led off
  pinMode(LED_PIN,OUTPUT); //nix drive active
  pinMode(LED_Vcc,OUTPUT); //vcc sw to leds, low=on
  digitalWrite(LED_Vcc,LOW); //vcc to leds. open in sleep
  
//  Serial.begin(9600);
  
  strip.begin();   // INITIALIZE strip
  strip.show();    
// strip.clear();  // Initialize all pixels to 'off'
  strip.setBrightness(brite); //(max = 255)

}

//////////////////////////////////////////////////////////////////

void loop() {
  if (allPatts[pattN][0]==2222) {
    rainbow(5);
    pattN++; 
    }
  if (allPatts[pattN][0]==3333) { lowPower(); }
  
   randomSeed(analogRead(3));
   colorWheel = random(255);  //start with different colors

  byte ledspot=0;
  byte bitspot=0;
  int  delayY  = allPatts[pattN][0];
  int  repeatT = allPatts[pattN][1];
  byte triangleN = 2;  //start in  allPatts[2]

///////////// print display section
while (repeatT>0) { //repeat of pattN
  
for (byte ik=0; ik<rows; ik++) { //count to 0-3 rows

////........................print 0 or 1 
for (byte iop=0; iop<maxBit; iop++) { //count 10 bits of triangleN
if ((allPatts[pattN][triangleN] >>((maxBit-1)-bitspot)) & 0x1 ==1) {   
  strip.setPixelColor(ledspot, Wheel(colorWheel));
}  else { 
  strip.setPixelColor(ledspot, strip.Color(0,0,0)); 
  }

ledspot++;
bitspot++;
} /////end count 10 bits of triangleN
////..................................................

bitspot=0;
triangleN++; 
 if (allPatts[pattN][triangleN]==pend) { //pend=1111
  triangleN=2; repeatT--;
 }
} //end count 4 rows

 strip.show();     // Update strip
 delay(delayY); //time found in allPatts[0] position 

 colorWheel++;

 ledspot=0; //resets inside repeat while
 bitspot=0;
 
} //end repeat


pattN++; //next pattern


}///end main
 



////////////////////////   functions    //////////////////////////
void wakeUp() { } //handler for pin interrupt.


void rainbow(int wait) {   // <7 ~ one minute
  for (byte looping=0; looping<8; looping++) { 
  for(long firstPixelHue = 0; firstPixelHue < 5*65536; firstPixelHue += 256) {
    for(int i=0; i<strip.numPixels(); i++) { // For each pixel in strip...
      int pixelHue = firstPixelHue + (i * 65536L / strip.numPixels());

      strip.setPixelColor(i, strip.gamma32(strip.ColorHSV(pixelHue)));
    }
    strip.show(); // Update strip with new contents
    delay(wait);  // Pause for a moment
  }
 } 
} //end rainbow  loop <6 ~ one minute

////////////////////////////
// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
WheelPos = 255 - WheelPos;
if(WheelPos < 85) {
return strip.Color(255 - WheelPos * 3, 0, WheelPos * 3,0);
}
if(WheelPos < 170) {
WheelPos -= 85;
return strip.Color(0, WheelPos * 3, 255 - WheelPos * 3,0);
}
WheelPos -= 170;
return strip.Color(WheelPos * 3, 255 - WheelPos * 3, 0,0);
}

/////////////////////////////////////////////
void lowPower(void) {
    pattN=0; //allPatts[0] start over after sleep
    pinMode(13,INPUT);
    pinMode(LED_PIN,INPUT); //nix drive inactive
    pinMode(LED_Vcc,INPUT); //Vcc leds OFF
 
      // Allow wake up pin to trigger interrupt on low.
    attachInterrupt(0, wakeUp, LOW);
    
    // Enter power down state with ADC and BOD module disabled.
    // Wake up when wake up pin is low.
    LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF); 

    // Disable external pin interrupt on wake up pin.
    detachInterrupt(0); 

    //// awake here, turn stuff on
  pinMode(LED_PIN,OUTPUT); //nix drive active
  pinMode(LED_Vcc,OUTPUT); //vcc sw to leds
  digitalWrite(LED_Vcc,0); //vcc to leds. open in sleep

    ////checks battery level 
  ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  delay(2);
  ADCSRA |= _BV(ADSC);
  while (bit_is_set(ADCSRA, ADSC));
  int  bval = 1126400L / (ADCL | (ADCH << 8)); //3647=3.647v
  
  ADMUX=0; //reset to default

   if (bval/100 < 30) { //batt low flash red leds
    for (byte dfg=0; dfg<16; dfg++) {
      strip.clear();  // Initialize all pixels to 'off'
      strip.setPixelColor(0, strip.Color(255,0,0) );
      strip.setPixelColor(30, strip.Color(255,0,0) );
      strip.show();
      delay(200);
      strip.setPixelColor(0, strip.Color(0,0,0) );
      strip.setPixelColor(30, strip.Color(0,0,0) );
      strip.show();
      delay(50);
   }
       lowPower();
  }

} //end lowPower

/////////////////////////////////////////////

